"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_i_1 = require("fs-i");
const fs_extra_1 = require("fs-extra");
function replaceProjectName(path, answer) {
    return __awaiter(this, void 0, void 0, function* () {
        let files = yield fs_i_1.getAllFiles(path);
        for (let file of files) {
            let fileContent = fs_extra_1.readFileSync(file, { encoding: "utf-8" });
            fileContent = fileContent.replace(/{{projectName}}/g, answer.projectName);
            fileContent = yield editPackageJson(file, fileContent, answer);
            fs_extra_1.writeFileSync(file, fileContent);
        }
    });
}
function editPackageJson(file, fileContent, answer) {
    return __awaiter(this, void 0, void 0, function* () {
        file = file.replace(/\\/g, "/");
        file = file.substr(file.lastIndexOf("/") + 1);
        if (file === "package.json") {
            if (answer.needDocs === "否") {
                let json = JSON.parse(fileContent);
                delete json.devDependencies.typedoc;
                delete json.scripts.docs;
                json.scripts.build = json.scripts.build.replace(/\s*&&\s*npm\s*run\s*docs\s*/, "");
                fileContent = JSON.stringify(json, null, 2);
            }
            if (answer.unittest === "否") {
                let json = JSON.parse(fileContent);
                delete json.devDependencies["@types/chai"];
                delete json.devDependencies["@types/mocha"];
                delete json.devDependencies["source-map-support"];
                delete json.devDependencies["ts-node"];
                delete json.devDependencies.chai;
                delete json.devDependencies.coveralls;
                delete json.devDependencies.mocha;
                delete json.devDependencies.nyc;
                delete json.scripts.test;
                delete json.scripts["test-nyc"];
                delete json.nyc;
                json.scripts.build = json.scripts.build.replace(/\s*&&\s*npm\s*run\s*docs\s*/, "");
                fileContent = JSON.stringify(json, null, 2);
            }
        }
        return fileContent;
    });
}
function createProjectWithUnitTest(answer) {
    return __awaiter(this, void 0, void 0, function* () {
        let targetPath = `${process.cwd()}/${answer.projectName}`;
        fs_extra_1.copySync(`${__dirname}/../template/projectWithUnitTest`, targetPath);
        replaceProjectName(targetPath, answer);
    });
}
exports.createProjectWithUnitTest = createProjectWithUnitTest;
function createProject(answer) {
    return __awaiter(this, void 0, void 0, function* () {
        createProjectWithUnitTest(answer);
    });
}
exports.createProject = createProject;
//# sourceMappingURL=createProject.js.map